#include<plang/prog.hpp>

#include<iostream>
using namespace std;

plang::factor::shared_ptr write(plang::factor::vector& argv){
	try{
		if(argv.size()!=1)
			throw plang_exception("invalid argument count");
		argv.at(0)->write_ostream(std::wcout);
		return plang::factor::shared_ptr(new plang::nil());
	}
	catch(const std::exception& e){
		throw plang_exception("catch exception").append(e);
	}
}

class test{
public:
	int i;

	test(){
		i=0;
	}

	void define_print(plang::prog<wchar_t>& prog){
		prog.global.define_native(L"print1",boost::bind1st(boost::mem_fun(&test::print),this));
	}

	plang::factor::shared_ptr print(plang::factor::vector& argv){
		std::wcout<<"print test"<<++i<<std::endl;
		return plang::factor::shared_ptr(new plang::nil());
	}
};

int main(int argc, char* argv[]){
	_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
	std::locale wloc(std::locale("japanese"),&std::use_facet<std::numpunct<wchar_t>>(std::locale::classic()));
	std::locale::global(wloc);

	try{
		if(argc<2)
			throw plang_exception("invalid argument count, argc=")+argc+" argv[0]"+argv[0];

		test a;
		plang::prog<wchar_t> prog;
		lib::filesystem<wchar_t>::path p=lib::cast<std::wstring>(argv[0]).target;
		p.pop_back();
		prog.set_include_directory(p.str());
		prog.global.define_native(L"write",write);
		a.define_print(prog);
		prog.global.define_native(L"print2",boost::bind1st(boost::mem_fun(&test::print),&a));
		prog.compile(lib::cast<std::wstring>(argv[1]));

		plang::factor::vector v;
		for(int i=2; i<argc; ++i)
			v.push_back(plang::factor::shared_ptr(new plang::string_<wchar_t>(lib::cast<std::wstring>(argv[i]))));

		prog.start(L"main",v);
		while(prog.process_count())
			prog.run();
	}
	catch(const std::exception& e){
		cout<<e.what()<<endl;
	}

	int i;
	cin>>i;

	return 0;
}
