#include<core/system.hpp>

system sys;
list who;

bool P(string s, unsigned int& mutex){
	if(mutex){
		sys.printl("begin read@"+s);
		--mutex;
		who.push_back(s);
		return true;
	}
	sys.printl("wait@"+s);
	return false;
}

nil V(unsigned int& mutex){
	++mutex;
	sys.printl("end read@"+who.pop_front());
}

inline P(string p, unsigned int& mutex){
	while(!P(p,mutex));
}

inline V(unsigned int& mutex){
	V(mutex);
}

inline read(string p, unsigned int& mutex){
	inline P(p,mutex);
	sys.printl("do read, who="+using::debug(who));
	inline V(mutex);
}

process proc3(unsigned int& mutex){
	int i=5;
	while(--i){
		inline read("proc3",mutex);
	}
}

process proc2(unsigned int& mutex){
	int i=5;
	while(--i){
		inline read("proc2",mutex);
	}
}

process proc1(unsigned int& mutex){
	int i=5;
	while(--i){
		inline read("proc1",mutex);
	}
}

process main(){
	unsigned int mutex=2;
	process::proc1 p1(mutex);
	process::proc2 p2(mutex);
	process::proc3 p3(mutex);

	while(!p1.exit()||!p2.exit()||!p3.exit())
		inline read("main",mutex);
}
